function [vertices, L] = CreatePolygonAndGluingData(border_edges)
%% this function creates a polygon corresponding to border_edges and computes 
%% the gluing data for the welding process

% rearranging border_edges
for j = 1:size(border_edges,1)-1
    [~,minimum_index] = min(abs(border_edges(:,2) - border_edges(j,end)));
    tmp = border_edges(j+1,:);
    border_edges(j+1,:) = border_edges(minimum_index,:);
    border_edges(minimum_index,:) = tmp;
end

% compute gluing data in L
L = zeros(size(border_edges,1)/2,2);
for j = 1:size(border_edges,1)/2
   L(j,:) = find(border_edges(:,1)==j);
end

L(1,:) = fliplr(L(1,:));
L2 = zeros(size(L));

% sort L with regard to distance of edges
ct = 1;
for j = 1:size(border_edges,1)/2
    for i = 1:size(L,1)
        if mod(L(i,1)-L(i,2),size(border_edges,1)) == mod(j,size(border_edges,1)) || mod(L(i,2)-L(i,1),size(border_edges,1)) == mod(j,size(border_edges,1))
            L2(ct,:) = fliplr(L(i,:));
            ct = ct + 1;
        end
    end
end
L = L2;

for j = 1:size(L,1)
    if mod(L(j,1)-L(j,2),size(border_edges,1)) > mod(L(j,2)-L(j,1),size(border_edges,1))
        L(j,:)=fliplr(L(j,:));
    end
end

vertices = border_edges(:,end);
end